%{!?luaver: %global luaver %(lua -e "print(string.sub(_VERSION, 5))" || echo 0)}
%global lualibdir %{_libdir}/lua/%{luaver}
%global luapkgdir %{_datadir}/lua/%{luaver}

%global luacompatver 5.1
%global luacompatlibdir %{_libdir}/lua/%{luacompatver}
%global luacompatpkgdir %{_datadir}/lua/%{luacompatver}

%global luapkgname cqueues

Name:           lua-%{luapkgname}
Version:        20200603
Release:    2%{?dist}
Summary:        Stackable Continuation Queues for the Lua Programming Language

License:        MIT
URL:            https://github.com/wahern/%{luapkgname}
Source0:        https://github.com/wahern/%{luapkgname}/archive/rel-%{version}/%{name}-%{version}.tar.gz
Patch0:         lua-cqueues-20200603-lua-5.4.patch
BuildRequires:  gcc
BuildRequires:  m4
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  lua
BuildRequires:  lua-devel >= %{luaver}
BuildRequires:  compat-lua-devel

Requires:       lua(abi) = %{luaver}

%description
cqueues is a type of event loop for Lua. It doesn't use callbacks but instead
you communicate with an event controller by the yielding and resumption of
Lua coroutines using objects.

cqueues are stackable. Each instantiated cqueue is a poll-able object which
can be polled from another cqueue, or another event loop system entirely.
The design is meant to be non-intrusive, composable, and embeddable within
existing applications.

cqueues includes a sockets library with DNS, buffering, end-of-line
translation, SSL/TLS, and descriptor passing support builtin.
Domain querying, connection establishment, and SSL negotiation are handled
transparently as part of a state machine entered with every I/O operation,
so users can read and write immediately upon instantiating the object,
as if opening a regular file.

cqueues also includes modules for handling signals, threads, and file change
notifications using native kernel facilities and accessible through easy
to use interfaces which abstract the different kernel facilities.

%package -n lua%{luacompatver}-%{luapkgname}
Summary:        Stackable Continuation Queues for the Lua Programming Language %{luacompatver}
Requires:       compat-lua-libs

%description -n lua%{luacompatver}-%{luapkgname}
Compatibility package for Lua %{luacompatver}

%package doc
Summary:        Documentation for the Stackable Continuation Queues library
BuildArch:      noarch
Requires:       %{name} == %{version}

%description doc
Documentation for the Stackable Continuation Queues library
for the Lua Programming Language

%prep
%setup -q -n %{luapkgname}-rel-%{version}
%patch0 -p1 -b .lua54

%build
export CFLAGS="%{?optflags} -fPIC"
export LDFLAGS="%{?build_ldflags}"
make LUA_APIS="%{luaver}" %{?_smp_mflags} prefix=%{_prefix} libdir=%{_libdir}

make LUA_APIS="%{luacompatver}" %{?_smp_mflags} prefix=%{_prefix} libdir=%{_libdir} CFLAGS="$CFLAGS -I%{_includedir}/lua-%{luacompatver}"

%install
make install LUA_APIS="%{luaver}" DESTDIR=%{buildroot} prefix=%{_prefix} libdir=%{_libdir}
make install LUA_APIS="%{luacompatver}" DESTDIR=%{buildroot} prefix=%{_prefix} libdir=%{_libdir}

mkdir -p %{buildroot}%{_pkgdocdir}
cp -r -t %{buildroot}%{_pkgdocdir} doc/cqueues.pdf examples
sed -i '1 s|^#!/.*$|#!/usr/bin/lua|' %{buildroot}%{_pkgdocdir}/examples/*


%files
%{luapkgdir}/*
%{lualibdir}/*
%license LICENSE

%files -n lua%{luacompatver}-%{luapkgname}
%{luacompatpkgdir}/*
%{luacompatlibdir}/*
%license LICENSE

%files doc
%defattr(644,root,root,755)
%doc %{_pkgdocdir}/*
%license LICENSE

%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 20200603-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20200603-1
- initial build
